/*
 * @(#)Coran.java    Cum 09 Eki 2009 12:11:19 CEST
 *
 * Murat iNAN, muratsivas76@gmail.com
 */
package net.dilmerkezi.coran;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.text.*;

import java.io.*;

import java.util.*;

//custom
import net.dilmerkezi.sures.*;


/**
 * Coran en lengua espanola.
 * P.s: Nosotros recibimos la traducion de Coran
 *      desde arabe a espanol desde islamelsalvador.com
 *
 * @author Murat iNAN
 */
public final class Coran
           extends JPanel
	implements Serializable, ActionListener, ItemListener
{

    /** Menu bar*/
    static private final JMenuBar mb = new JMenuBar ();
    
    /** JTextPane object*/
    private JTextPane tp;
    
    /** Styled document*/
    static private StyledDocument doc = null;
    
    /** Write process info here */
    protected JLabel infoLabel;
    
    /** A combobox for holding sures*/
    protected static JComboBox combosure;
    
    /** A combobox for holding selected sure ayet nums*/
    protected static JComboBox combonum;
    
    /** Total object*/
    private static final Total total = Total.getTotal ();
    
    /** Current sura*/
    private static Sure curSure = total.getPrimerSure ();
    
    /** Licence string*/
    private static final String licencestr = getLicenceStr ();
    
    /** Guide string*/
    private static final String guidestr = getGuideStr ();
    
    
    /** Singleton constructor*/
    private Coran ()
    {
        super (new BorderLayout ());
	
	tp = getTextPane ();
	doc = tp.getStyledDocument ();	
	
	infoLabel = getLabel ();
	
	JPanel npanel = new JPanel (new BorderLayout ());
	npanel.setPreferredSize (new Dimension (800, 30));
	npanel.add ("Center", mb);
	
	//-------------
	JMenu fileMenu = getMenu ("Archivo");
	mb.add (fileMenu);
	
	JMenuItem infoItem = getItem ("Infos");
	infoItem.addActionListener (new ActionListener ()
	{
	    public void actionPerformed (ActionEvent evt)
	    {
	        Thread th = new Thread ()
		{
		    public void run ()
		    {
		        infoLabel.setText ("Espera por favor!");
	                total.info (tp, doc);
			infoLabel.setText ("Esta listo!");
		    }
		};
		th.start ();
	    }
	});
	fileMenu.add (infoItem);
	
	fileMenu.addSeparator ();
	
	JMenuItem exitItem = getItem ("Salir");
	exitItem.addActionListener (new ExitListener ());
	fileMenu.add (exitItem);
	//-------------
	
	JMenu editMenu = getMenu ("Edita");
	mb.add (editMenu);
	
	JMenuItem findItem = getItem ("Busca");
	findItem.addActionListener (this);
	editMenu.add (findItem);
	
	final JMenuItem stopItem = getItem ("Stop");
	stopItem.addActionListener (new ActionListener ()
	{
	    public void actionPerformed (ActionEvent evt)
	    {
	//        boolean stp = total.getStop ();
	//	if (stp)
	//	{
	//	    total.setStop (false);
	//	    stopItem.setText ("Stop");
	//	}
	//	else
	//	{
		    total.setStop (true);
	//	    stopItem.setText ("Continua");
	//	}
	    }
	});
	editMenu.add (stopItem);
	
	editMenu.addSeparator ();
	
	JMenuItem fastItem = getItem ("Rapid");
	fastItem.addActionListener (new FastListener ());
	editMenu.add (fastItem);
	
	editMenu.addSeparator ();
	
	JMenuItem allItem = getItem ("Todo Coran");
	allItem.addActionListener (new ActionListener ()
	{
	    public void actionPerformed (ActionEvent evt)
	    {
	        Thread th = new Thread ()
		{
		    public void run ()
		    {
		        infoLabel.setText ("Espera por favor!!");
			total.writeAll (tp, doc);
			infoLabel.setText ("Esta listo!");
			return;
		    }
		};
		th.start ();
	    }
	});
	editMenu.add (allItem);
	//---------------
	
	JMenu generateMenu = getMenu ("Produce");
	mb.add (generateMenu);
	
	JMenuItem unoItem = getItem ("Uno");
	unoItem.addActionListener (new ActionListener ()
	{
	    public void actionPerformed (ActionEvent evt)
	    {
	        Thread thr = new Thread ()
		{
		    public void run ()
		    {
		       String s = JOptionPane.showInputDialog (
		        mb,
		        "P.s: Hay 114 sures en Coran.\nEscribe el numero de sure que quieres\ngrabarlo aun archivo en tu computadoora:\n");
			if (s == null) return;
			int num = 0;
			try
			{
			    num = Integer.parseInt (s);
			}
			catch (Exception e)
			{
			    return;
			}
			
			infoLabel.setText ("");
			//if (num < 1 || num > 114) return;
			boolean b = total.generateUno (num, infoLabel);
			if (b)
			{
			//    infoLabel.setText ("sure"+num+".txt esta listo!");
			}
			else
			{
			    infoLabel.setText ("Ha sido un error!!!");
			}
			return;
		    }
		};
		thr.start ();
	    }
	});
	generateMenu.add (unoItem);
	
	JMenuItem todoItem = getItem ("Todo");
	todoItem.addActionListener (new ActionListener ()
	{
	    public void actionPerformed (ActionEvent evt)
	    {
	        Thread thr = new Thread ()
		{
		    public void run ()
		    {
		        infoLabel.setText ("Espera por favor!");
			total.generateAll (infoLabel);
			//infoLabel.setText ("Coran.txt esta listo!");
			return;
		    }
		};
		thr.start ();
	    }
	});
	generateMenu.add (todoItem);
	//---------------
	
	JMenu helpMenu = getMenu ("Ayuda");
	mb.add (helpMenu);
	
	JMenuItem licenceItem = getItem ("License");
	final LicenceListener licencelistener = new LicenceListener ();
	licenceItem.addActionListener (licencelistener);
	helpMenu.add (licenceItem);
	
	JMenuItem guideItem = getItem ("Guia");
	final GuideListener guidelistener = new GuideListener ();
	guideItem.addActionListener (guidelistener);
	helpMenu.add (guideItem);
	//--------------
	add ("North", npanel);
	
	JPanel cpanel = new JPanel (new BorderLayout ());
	
	JScrollPane jp = new JScrollPane ();
	JViewport port = jp.getViewport ();
	port.add (tp);
	
	cpanel.add ("Center", jp);
	
	add ("Center", cpanel);
	
	JPanel spanel = new JPanel (new GridLayout (2, 0));
	spanel.setPreferredSize (new Dimension (800, 50));
	
	JPanel s1panel = new JPanel (new GridLayout (0, 4));

	combosure = getComboBox ();
	combonum = getComboBox ();
	
	combosure.addItemListener (this);
	Sure s [] = total.getSures ();
	final int len = s.length;
	
	for (int i=0; i<len; i++)
	{
	    combosure.addItem (s [i]);
	}
	
	combosure.setSelectedIndex (0);
	s1panel.add (combosure);
	
	String st [] = {"1", "2", "3", "4", "5", "6", "7"};
	for (int i=0; i<7; i++)
	{
	    combonum.addItem (st [i]);
	}
	
//	combonum.setSelectedIndex (0);
	combonum.addActionListener (new ActionListener ()
	{
	    public void actionPerformed (ActionEvent evt)
	    {
	         if (curSure == null) return;
	         int num = curSure.getSureNo ();
	         StringBuffer sb = new StringBuffer ();
	         sb.append (Integer.toString (num));
	         sb.append (":");
	         int ic = combonum.getSelectedIndex ();
	         sb.append (Integer.toString (ic+1));
	         sb.append (" --> ");
	         String ayet = curSure.getAyetes () [ic+1];
	         sb.append (ayet);
	         try
	         {
	             doc.remove (0x0000, doc.getLength ());
	             doc.insertString (doc.getLength (),
		         sb.toString (), total.getStm3 ());
	         }
	         catch (Exception e)
	         {
	             e.printStackTrace ();
		     return;
	         }
	    };
	});
	
	s1panel.add (combonum);
	
	JButton allButton = getButton ("Todo");
	allButton.addActionListener (new ActionListener ()
	{
	    public void actionPerformed (ActionEvent evt)
	    {
	        Thread thr = new Thread ()
		{
		     public void run ()
		     {
		         infoLabel.setText ("Espera por favor!");
			 if (curSure != null)
			 {
			     try 
			     { 
			         doc.remove (0, doc.getLength ());
			     }
			     catch (Exception e)
			     {}
	                     total.writeSure (tp, curSure, doc);
			     infoLabel.setText ("Esta listo!");
			 }
			 else
			 {
			     infoLabel.setText ("WARNING: No Esta listo!");
			 }
			 return;
		     }
		};
		thr.start ();
	    }
	});
	s1panel.add (allButton);
	
	JButton exitButton = getButton ("Exit");
	exitButton.addActionListener (new ExitListener ());
	s1panel.add (exitButton);
	
	spanel.add (s1panel);
	
	JPanel s2panel = new JPanel (new BorderLayout ());
	
	s2panel.add ("Center", infoLabel);
	
	spanel.add (s2panel);
	
	add ("South", spanel);
    } //constructor end
    
    /** @return Licence string*/
    static private final String getLicenceStr ()
    {
        StringBuffer sb = new StringBuffer ();
	sb.append ("<html><body>");
	sb.append ("<font family=\"Dialog\" color=\"blue\" size=\"5\">");
	sb.append ("La Traduccion: www.islamelsalvador.com");
	sb.append ("<p>islamelsalvador@gmail.com");
	sb.append ("<p><p>Programaci\u00F3n: Murat iNAN, muratsivas76@gmail.com");
	sb.append ("<p>www.dilmerkezi.net/eng.html");
	sb.append ("<p><p>La licencia de \u00E9ste programa es GNU/GPL.");
	sb.append ("<p>Puedes publicarlo y puedes enviarlo");
        sb.append ("<p>a los todos, es gratis y libre.");
	sb.append ("</font></body></html>");
        return sb.toString ();
    }

    /** @return Guide string*/
    static private final String getGuideStr ()
    {
        StringBuffer sb = new StringBuffer ();
	sb.append ("<html><body bgcolor=\"FFFFFF\">");
	sb.append ("<font family=\"Dialog\" color=\"blue\" size=\"4\"><b>");
	sb.append ("<b>1:</b> Abre coran.zip archivo (Extract here) y entra en Coran folder.");
	sb.append ("<p><b>2:</b> Lee README.TXT y LICENCE.TXT");
	sb.append ("<p><b>3:</b> Entra en dist folder");
	sb.append ("<p><b>4:</b> Si tienes java sin problemas haz doble click sobre coran.jar");
	sb.append ("<p>Si no tienes java puedes bajarlo desde www.java.com gratuitamente");
	sb.append ("<p><p><b>5:</b> Si hay problemas en abrir prueba uno de siguientes;");
	sb.append ("<p><p><b>A:</b> Rename runbat como run.bat y haz doble click sobre run.bat");
	sb.append ("<p><b>B:</b> Rename run2bat como run2.bat y haz doble click sobre run2.bat");
	sb.append ("<p><p><b>C:</b> Ven a dist folder en MS DOS Command");
	sb.append ("<p>y escribe ese mando siguiente:");
	sb.append ("<p><b><i>java -jar coran.jar</i></b>");
	sb.append ("<p><p>Los Men\u00FAs:");
	sb.append ("<p><b>Archivo/Infos:</b> Escribe infos generales de todos suras a la escena de programa");
	sb.append ("<p><b>Archivo/Salir:</b> Cierra la programa");
	sb.append ("<p><b>Edita/Busca:</b> Entra la palabra para buscar en Coran");
	sb.append ("<p><b>Edita/Stop:</b> Stop progresion");
	sb.append ("<p><b>Edita/Rapid:</b> Encontra el aleya escribi\u00E9ndolo como 65:2");
	sb.append ("<p><b>Edita/Todo Coran:</b> Escribe todo Coran a la escena de programa");
	sb.append ("<p><b>Produce/Uno:</b> Produce un sura como txt archivo");
	sb.append ("<p><b>Produce/Todo:</b> Escribe todo Coran a un archivo se llama Coran.txt");
	sb.append ("<p><b>Help/Licence:</b> Muestra Licence del Programa");
	sb.append ("<p><b>Help/Guide:</b> Muestra esta escena de gu\u00EDa");
	sb.append ("<p><b>Sure Combobox:</b> Elige la sura");
	sb.append ("<p><b>Numero Combobox:</b> Elige el numero de aleya");
	sb.append ("<p><b>Todo:</b> Escribe la sura que elegiste a la escena de la programa");
	sb.append ("<p><b>Salir:</b> Cierra la programa");
	sb.append ("</b></font></body></html>");
        return sb.toString ();
    }
    
    //----------------------------
    /** Type the ayetes rapidly*/
    private final class FastListener
             implements ActionListener
    {
        
        /** @param evt Action event object*/
        final public void actionPerformed (ActionEvent evt)
	{
//	    System.out.println ("Bu men\u00FC haz\u0131r de\u011Fil");
            final String s = JOptionPane.showInputDialog (
	        mb,
		"Entra sure y ayet number en este formato\nSure:Ayet como\n65:2");
	    if (s == null) return;
	    Thread t = new Thread ()
	    {
	        public void run ()
		{
		    infoLabel.setText ("");
		    boolean b = total.printAyet (s, doc, false);
		    if (!b) infoLabel.setText ("Ha sido un error!!");
		    return;
		}
	    };
	    t.start ();
	    return;
	}
	
    }
    //------------------------
    

    //----------------------------
    /** Shows licence */
    private final class LicenceListener
             implements ActionListener
    {
        
        /** @param evt Action event object*/
        final public void actionPerformed (ActionEvent evt)
	{
	//    System.out.println ("Bu men\u00FC haz\u0131r de\u011Fil");
	    JOptionPane.showMessageDialog (mb, licencestr);
	    return;
	}
	
    }
    //------------------------    
    
    //----------------------------
    /** Shows the guide */
    private final class GuideListener
             implements ActionListener
    {

        /** @param evt Action event object*/
        public void actionPerformed (ActionEvent evt)
	{
//	    System.out.println ("Bu men\u00FC haz\u0131r de\u011Fil");
	    JOptionPane.showMessageDialog (mb, guidestr);
	    return;
	}

    }
    //------------------------    
    
    /** @return A custom combobox*/
    private final JComboBox getComboBox ()
    {
        JComboBox box = new JComboBox ();
//	box.addItemListener (this);
	//box.setForeground (Color.orange.darker ());
	Font fnt = box.getFont ();
	if (fnt != null)
	{
	    String fami = fnt.getFamily ();
	    int stl = 0x0001;
	    int size = fnt.getSize ();
	    Font f = new Font (fami, stl, size+2);
	    box.setFont (f);
	}
	
	box.setMaximumRowCount (19);
	return box;
    }
    
    /** @return A custom label*/
    final private JLabel getLabel ()
    {
        JLabel label = new JLabel ("", JLabel.LEFT);
	label.setForeground (Color.blue.darker ());
	return label;
    }
    
    /**
     * @param str The text of button
     * @return A custom JButton object
     */
    private final JButton getButton (String str)
    {
        JButton b = new JButton (str);
	b.setForeground (Color.blue);
	return b;
    }
    
    /**
     * @return A custom text pane
     */
    private final JTextPane getTextPane ()
    {
        JTextPane tp = new JTextPane ();
	tp.setEditable (false);
	return tp;
    }
    
    /**
     * @param str The text of menu
     * @return A custom menu object 
     */    
    private final JMenu getMenu (String str)
    {
        JMenu me = new JMenu (str);
	me.setForeground (Color.blue);
	return me;
    }
    
    /**
     * @param str The text of menu item
     * @return A custom menu item object 
     */
    final private JMenuItem getItem (String str)
    {
        JMenuItem mi = new JMenuItem (str);
	mi.setForeground (Color.blue);
	return mi;
    }
    
    /**
     * Inner exit action
     */
    private static final class ExitListener
                    implements ActionListener
    {

        /**
	 * Closes program
	 *
	 * @param evt Action event object
	 */
        public void actionPerformed (ActionEvent evt)
	{
	    System.exit (-1);
	}
	
    }
    /** Inner exit action end*/
    
    /** @param evt Action event object*/
    final public void actionPerformed (ActionEvent evt)
    {
        //System.out.println ("This action is not ready");
	Thread thr = new Thread ()
	{
	    public void run ()
	    {
	        String s = JOptionPane.showInputDialog (mb,
		 "Entra la palabra para buscar:");
		if (s == null) return;
		infoLabel.setText ("Espera por favor!");
		total.search (tp, s, doc, false);
		infoLabel.setText ("Esta listo!");
		return;
	    }
	};
	thr.start ();
    }
    
    /** @param evt Item event object*/
    final public void itemStateChanged (ItemEvent evt)
    {
         if (!initialized) return;
	 infoLabel.setText ("");
         Object obj = evt.getSource ();
	 JComboBox cbx = (JComboBox)obj;
	 if (cbx == combosure)
	 {
	    // System.out.println ("Combosure");
	    Object item = cbx.getSelectedItem ();
	    Sure sure = (Sure)item;
	    if (sure != null)
	    {
	        curSure = sure;
		int alen = curSure.getAyetCount ();
		combonum.removeAllItems ();

		for (int i=0; i<alen; i++)
		{
		    combonum.addItem (Integer.toString (i+1));
		}
	    }
	    else return;
	 }
	 else
	 {
	     return;
	 }
    }
    
    /** Shows screen*/
    private static final void showScreen ()
    {
        String os = System.getProperty ("os.name");
	System.out.println ("OS: "+os);
	
	try
	{
	    if (os.indexOf ("Windows") != -1)
	    {
	        UIManager.setLookAndFeel 
	            ("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
	    }
	    else
	    {
	        UIManager.setLookAndFeel
		    ("com.sun.java.swing.plaf.nimbus.NimbusLookAndFeel");
	    }
	}
	catch (Exception e)
	{}
	
        JFrame fr = new JFrame ("dilmerkezi.net/eng.html & islamelsalvador.com");
	fr.setDefaultCloseOperation (JFrame.EXIT_ON_CLOSE);
	
	JComponent jc = new Coran ();
	jc.setOpaque (true);
	fr.setContentPane (jc);
	
	fr.pack ();
	fr.setSize (WDTH, HGHT);
	fr.setResizable (true);
	fr.setLocationRelativeTo (null);
	fr.setVisible (true);
    }
    
    /** Initialized??*/
    private static boolean initialized = false;
    
    static int WDTH = 800, HGHT = 600;
    
    public static final void main (String [] args)
    {
        if (args.length >= 2)
	{
	    try
	    {
	        WDTH = Integer.parseInt (args [0]);
		HGHT = Integer.parseInt (args [1]);
	    }
	    catch (Exception e)
	    {
	        WDTH = 800;
		HGHT = 600;
	    }
	}
	
        if (initialized)
	{
	    System.out.println ("System already running... Exiting !!!");
	    System.exit (-1);
	}
	
        javax.swing.SwingUtilities.invokeLater (new Runnable ()
	{
	    public void run ()
	    {
	        showScreen ();
		initialized = true;
	    }
	});
    }
    
} //class end
/*******************/
